samples = {"Modify all samples"}
ons = {}
flagS = {}
flagF = {}
flagsOff = {}
volumeInvert = {}
folder = 'Samples'
local utf8 = require("utf8")

function love.load()
  font = love.graphics.getFont()
  state = "setup"
  selector = 0
  decal = 0
  mousex = 0
  mousey = 0
  playOnHover = true
  love.window.setTitle("Müsicc")
end

function love.update(dt)
  oldx, oldy = love.mouse.getPosition()
  if oldx ~= mousex or oldy ~= mousey then mousectrl = true end
  mousex, mousey = love.mouse.getPosition()
  if state == "browsing" or state == "editing" then
    if mousectrl then selector = math.floor(mousey/20) end
    if selector < 2 then selector = 2 end
  end
end

function love.draw()
  if state == "editing" then
    local place = 1
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.rectangle("fill", 0, selector*20, 800, 20)
    if playOnHover then text = "true" else text = "false" end
    love.graphics.print("Samples: (Play on hover: " .. text .. ")", 0, 0)
    name = nil
    for i,v in pairs(samples) do
      place = place + 1
      if place == selector then 
        name = i
        love.graphics.setColor(0, 0, 0, 255) 
        for j,w in ipairs(ons) do
          if i == w then love.graphics.setColor(255, 0, 255, 255) end
        end
        if i ~= 1 then
          love.graphics.print(i, 0, place*20)
          love.graphics.setColor(255, 255, 255, 255) 
          love.graphics.rectangle("fill", 500, place*20, 300, 20)
          love.graphics.setColor(0, 0, 0, 255)
          love.graphics.print("P:" .. math.round(math.log(v:getPitch(), 2)*12, 0), 510, place*20)
          if volumeInvert[i] then love.graphics.setColor(255, 0, 0, 255) else love.graphics.setColor(0, 0, 0, 255) end
          love.graphics.print("V:" .. math.round(v:getVolume(), 1), 600, place*20)
          if not v:isStopped() then 
            if playOnHover then v:play() else v:pause() end
          end
        else
          love.graphics.print(v, 0, place*20)
        end
      else 
        love.graphics.setColor(255, 255, 255, 255)
        for j,w in ipairs(ons) do
          if i == w then love.graphics.setColor(0, 255, 0, 255) end
        end
        if i ~= 1 then 
          if not v:isStopped() then v:pause() end 
          love.graphics.print(i, 0, place*20)
          love.graphics.setColor(0, 0, 0, 255)
          love.graphics.rectangle("fill", 500, place*20, 300, 20)
          love.graphics.setColor(255, 255, 255, 255)
          love.graphics.print("P:" .. math.round(math.log(v:getPitch(), 2)*12, 0), 510, place*20)
          if volumeInvert[i] then love.graphics.setColor(0, 255, 255, 255) else love.graphics.setColor(255, 255, 255, 255) end
          love.graphics.print("V:" .. math.round(v:getVolume(), 1), 600, place*20)
        else
          love.graphics.print(v, 0, place*20)
        end
      end
      if i ~= 1 then
        for j,w in ipairs(ons) do
          if i == w and not v:isStopped() and v then v:play() end
        end
        love.graphics.setColor(0, 255, 0, 255)
        local total = v:getDuration("seconds")
        local pos = v:tell("seconds")
        love.graphics.rectangle("fill", 700, place*20+5, 100*(pos/total), 10)
        if v:isStopped() then 
          love.graphics.setColor(255, 0, 0, 255)
          love.graphics.rectangle("fill", 700, place*20+5, 100, 10) 
        end
        if flagS[i] then
          if flagsOff[i] then love.graphics.setColor(123, 123, 123, 255) else love.graphics.setColor(0, 0, 255, 255) end
          love.graphics.line(700 + 100 * (flagS[i]/total), place*20+5, 700 + 100 * (flagS[i]/total), place*20+15) 
        end
        if flagF[i] and i ~= 1 then 
          if not flagsOff[i] then love.graphics.setColor(255, 0, 0, 255) end
          love.graphics.line(700 + 100 * (flagF[i]/total), place*20+5, 700 + 100 * (flagF[i]/total), place*20+15) 
          if flagS[i] and not flagsOff[i] then
            love.graphics.setColor(255, 0, 255, 255)
            love.graphics.line(700 + 100 * (flagF[i]/total), place*20+10, 700 + 100 * (flagS[i]/total), place*20+10)
            if v:tell("seconds") >= flagF[i] and flagF[i] >= flagS[i] or v:tell("seconds") <= flagF[i] and flagF[i] <= flagS[i] then v:seek(flagS[i], "seconds") end
          end
        end
      end
    end
  end
  if state == "browsing" then
    for i,v in pairs(samples) do
      if i~= 1 then v:pause() end
    end
    local place = decal + 1
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.rectangle("fill", 0, selector*20, 800, 20)
    for i,v in ipairs(soundbase) do
      place = place + 1
      if place == selector then love.graphics.setColor(0, 0, 0, 255) else love.graphics.setColor(255, 255, 255, 255) end
      love.graphics.print(v, 0, place*20, 0, 1, 1)
    end
    love.graphics.setColor(0, 0, 0, 255)
    love.graphics.rectangle("fill", 0, 0, 800, 40)
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.print("Select a sample (.mp3, .ogg)", 0, 0)
    love.graphics.rectangle("fill", 0, 25, 800, 10)
  end
  if state == "change" then
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.print("Type a folder (Use \\ instead of /: 'C:\\users' is good, not 'C:/users')", 0, 0)
    love.graphics.print(folder .. "_", 0, 40)
  end
  if state == "setup" then
    soundbase = {}
    decal = 0
    print("Program searching at " .. folder)
    for file in io.popen("dir " .. folder .. "  /b"):lines() do 
      table.insert(soundbase, file)
      love.graphics.print("Searching samples..." .. #soundbase, 400, 300, 0, 2, 2, font:getWidth("Searching samples..." .. #soundbase)/2, font:getHeight()/2)
    end
    table.insert(soundbase, "Change folder...")
    state = "browsing"
  end
end

function love.mousepressed(x, y, button)
  if state == "editing" and button == 2 and name then 
    if name ~= 1 then
      samples[name]:setLooping(not samples[name]:isLooping())
      if samples[name]:isLooping() then 
        samples[name]:play() 
        if flagS[name] then samples[name]:seek(flagS[name], "seconds") end
      else 
        samples[name]:stop() 
      end
    else
      for i,v in pairs(samples) do
        if i ~= 1 then
          v:setLooping(not v:isLooping())
          if v:isLooping() then
            v:play()
            if flagS[i] and not flagsOff[i] then v:seek(flagS[i], "seconds") end
          else
            v:stop() 
          end
        end
      end
    end
  end
  if state == "editing" and button == 1 and name then 
    if name ~= 1 then 
      samples[name]:rewind() 
    else
      for i,v in pairs(samples) do
        if i ~= 1 then v:rewind() end
      end
    end
  end
  if state == "editing" and button == 3 and name then 
    if name ~= 1 then
      local go = true
      local pos = 0
      for i,v in ipairs(ons) do
        if v == name then 
          go = false 
          pos = i 
        end
      end
      if go then table.insert(ons, name) else table.remove(ons, pos) end
    else
      for i,v in pairs(samples) do
        if i ~= 1 then
          local go = true
          local pos = 0
          for j,w in ipairs(ons) do
            if w == i then 
              go = false 
              pos = j 
            end
          end
          if go then table.insert(ons, i) else table.remove(ons, pos) end
        end
      end
    end
  end
  if state == "browsing" and soundbase[selector-decal-1] then
    if soundbase[selector-decal-1] ~= "Change folder..." then
      samples[soundbase[selector-decal-1]] = love.audio.newSource(folder .. '/' .. soundbase[selector-decal-1])
      state = "editing"
      samples[soundbase[selector-decal-1]]:setLooping(true)
      samples[soundbase[selector-decal-1]]:play()
      samples[soundbase[selector-decal-1]]:pause()
      print("S: " .. soundbase[selector-decal-1])
    else
      folder = ""
      state = "change"
    end
  end
end

function love.wheelmoved(x, y)
  if y > 0 then y = 1 else y = -1 end
  if state == "browsing" then
    decal = decal + y
    if decal < -#soundbase + 1 then decal = -#soundbase + 1 end
    if decal > 0 then decal = 0 end
  end
  if state == "editing" and name then
    if name ~= 1 then
      local volume = samples[name]:getVolume()
      volume = volume + y/10
      if volume < 0 then volume = 0 end
      if volume > 1 then volume = 1 end
      samples[name]:setVolume(volume)
    else
      for i,v in pairs(samples) do
        if i ~= 1 then
          local volume = v:getVolume()
          if volumeInvert[i] then volume = volume - y/10 else volume = volume + y/10 end
          if volume < 0 then volume = 0 end
          if volume > 1 then volume = 1 end
          v:setVolume(volume)
        end
      end
    end
  end
end

function love.keypressed(key, scan)
  local once = true
  if scan == "space" and state == "editing" then playOnHover = not playOnHover end
  if scan == "escape" and state == "editing" then 
    state = "browsing" 
    once = false
  end
  if scan == "escape" and state == "browsing"  and once then state = "editing" end
  if scan == "return" and state == "browsing" then
    if soundbase[selector-decal-1] then
      if soundbase[selector-decal-1] ~= "Change folder..." then
        samples[soundbase[selector-decal-1]] = love.audio.newSource(folder .. '/' .. soundbase[selector-decal-1])
        state = "editing"
        samples[soundbase[selector-decal-1]]:setLooping(true)
        samples[soundbase[selector-decal-1]]:play()
        samples[soundbase[selector-decal-1]]:pause()
        print("S: " .. soundbase[selector-decal-1])
      else
        folder = ""
        state = "change"
      end
    end
  end
  if scan == "return" and state == "change" then state = "setup" end
  if scan == "backspace" and state == "change" then
    local byteoffset = utf8.offset(folder, -1)
    if byteoffset then folder = string.sub(folder, 1, byteoffset - 1) end
  end
  if scan == "up" and love.keyboard.isDown("lctrl", "rctrl") and state == "editing" and name then 
    if name ~= 1 then
      samples[name]:setPitch(2^(math.log(samples[name]:getPitch(), 2)+1/12)) 
    else
      for i,v in pairs(samples) do
        if i ~= 1 then v:setPitch(2^(math.log(v:getPitch(), 2)+1/12)) end
      end
    end
  end
  if scan == "down" and love.keyboard.isDown("lctrl", "rctrl") and state == "editing" and name then 
    if name ~= 1 then
      samples[name]:setPitch(2^(math.log(samples[name]:getPitch(), 2)-1/12)) 
    else
      for i,v in pairs(samples) do
        if i ~= 1 then v:setPitch(2^(math.log(v:getPitch(), 2)-1/12)) end
      end
    end
  end
  if scan == "left" and not love.keyboard.isDown("lctrl", "rctrl") and state == "editing" and name then
    if name ~= 1 then
      local volume = samples[name]:getVolume()
      volume = volume - 1/10
      if volume < 0 then volume = 0 end
      if volume > 1 then volume = 1 end
      samples[name]:setVolume(volume)
    else
      for i,v in pairs(samples) do
        if i ~= 1 then
          local volume = v:getVolume()
          if volumeInvert[i] then volume = volume + 1/10 else volume = volume - 1/10 end
          if volume < 0 then volume = 0 end
          if volume > 1 then volume = 1 end
          v:setVolume(volume)
        end
      end
    end
  end
  if scan == "right" and not love.keyboard.isDown("lctrl", "rctrl") and state == "editing" and name then
    if name ~= 1 then
      local volume = samples[name]:getVolume()
       volume = volume + 1/10
      if volume < 0 then volume = 0 end
      if volume > 1 then volume = 1 end
      samples[name]:setVolume(volume)
    else
      for i,v in pairs(samples) do
        if i ~= 1 then
          local volume = v:getVolume()
          if volumeInvert[i] then volume = volume - 1/10 else volume = volume + 1/10 end
          if volume < 0 then volume = 0 end
          if volume > 1 then volume = 1 end
          v:setVolume(volume)
        end
      end
    end
  end
  if scan == "left" and love.keyboard.isDown("lctrl", "rctrl") and state == "editing" and name and name ~= 1 then samples[name]:seek(samples[name]:tell("seconds") - 1, "seconds") end
  if scan == "right" and love.keyboard.isDown("lctrl", "rctrl") and state == "editing" and name and name ~= 1 then samples[name]:seek(samples[name]:tell("seconds") + 1, "seconds") end
  if scan == "up" and not love.keyboard.isDown("lctrl", "rctrl") and state == "editing" then
    selector = selector - 1
    mousectrl = false
  end
  if scan == "down" and not love.keyboard.isDown("lctrl", "rctrl") and state == "editing" then
    selector = selector + 1
    mousectrl = false
  end
  if scan == "return" and state == "editing" and name then
    if name ~= 1 then
      local go = true
      local pos = 0
      for i,v in ipairs(ons) do
        if v == name then 
          go = false 
          pos = i 
        end
      end
      if go then table.insert(ons, name) else table.remove(ons, pos) end
    else
      for i,v in pairs(samples) do
        if i ~= 1 then
          local go = true
          local pos = 0
          for j,w in ipairs(ons) do
            if w == i then 
              go = false 
              pos = j 
            end
          end
          if go then table.insert(ons, i) else table.remove(ons, pos) end
        end
      end
    end
  end
  if scan == "delete" and state == "editing" and name and name ~= 1 then 
    samples[name]:stop()
    samples[name] = nil 
  end
  if scan == "s" and state == "editing" and name and name ~= 1 then if flagS[name] then flagS[name] = nil else flagS[name] = samples[name]:tell("seconds") end end
  if scan == "f" and state == "editing" and name and name ~= 1 then if flagF[name] then flagF[name] = nil else flagF[name] = samples[name]:tell("seconds") end end
  if scan == "d" and state == "editing" and name then 
    if name ~= 1 then
      if flagsOff[name] then flagsOff[name] = nil else flagsOff[name] = true end
    else 
      for i,v in pairs(samples) do
        if flagsOff[i] then flagsOff[i] = nil else flagsOff[i] = true end
      end
    end
  end
  if scan == "e" and state == "editing" and name then
    if name ~= 1 then
      if volumeInvert[name] then volumeInvert[name] = nil else volumeInvert[name] = true end
    else
      for i,v in pairs(samples) do
        if volumeInvert[name] then volumeInvert[name] = nil else volumeInvert[name] = true end
      end
    end
  end
  if scan == "up" and state == "browsing" then 
    selector = selector - 1
    if selector < 2 then decal = decal + 1 end
    if decal > 0 then decal = 0 end
    moucectrl = false
  end
  if scan == "down" and state == "browsing" then
    selector = selector + 1
    if selector > 29 then 
      decal = decal - 1 
      selector = selector - 1
    end
    if decal < -#soundbase + 1 then decal = -#soundbase + 1 end
    mousectrl = false
  end
end

function love.textinput(text)
  if state == "change" then folder = folder .. text end
end

function math.round(x, y)
  num = y or 0
  if math.floor(x*10^num)+0.5 > x*10^num then return math.floor(x*10^num)/10^num else return (math.floor(x*10^num)+1)/10^num end
end